Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Class ExtensionFunctionCall

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall
              net.sf.saxon.functions.ExtensionFunctionCall

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public class ExtensionFunctionCall

extends FunctionCall

This class acts as a container for an extension function defined to call a method in a user-defined class.

Note that the binding of an XPath function call to a Java method is done in class `JavaExtensionLibrary`

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`ExtensionFunctionCall()` Default constructor

Method Summary
`void` | `checkArguments(StaticContext env)` Method called by the expression parser when all arguments have been supplied
`int` | `computeCardinality()`
`int` | `getIntrinsicDependencies()` Determine which aspects of the context the expression depends on.
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the expression, if possible.
`Class` | `getTargetClass()` Get the class containing the method being called
`AccessibleObject` | `getTargetMethod()` Get the target method (or field, or constructor) being called
`void` | `init(int nameCode, Class theClass, AccessibleObject object, Configuration config)` Initialization: creates an ExtensionFunctionCall
`SequenceIterator` | `iterate(XPathContext context)` Evaluate the function.
`Expression` | `preEvaluate(StaticContext env)` preEvaluate: this method suppresses compile-time evaluation by doing nothing (because the external function might have side-effects and might use the context)
`static String` | `toCamelCase(String name, boolean debug, PrintStream diag)` Convert a name to camelCase (by removing hyphens and changing the following letter to capitals)
`boolean` | `usesFocus()` Determine whether this method uses the focus.

Methods inherited from class net.sf.saxon.expr.FunctionCall
`display, getArguments, getDisplayName, getFunctionNameCode, getNumberOfArguments, iterateSubExpressions, optimize, promote, replaceSubExpression, setArguments, setFunctionNameCode, simplify, typeCheck`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeSpecialProperties, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ExtensionFunctionCall

    public ExtensionFunctionCall()

  Default constructor

Method Detail

### init

    public void init(int nameCode,
                     Class theClass,
                     AccessibleObject object,
                     Configuration config)

  Initialization: creates an ExtensionFunctionCall

  Parameters:
    `nameCode` - the name code of the function, for display purposes
    `theClass` - the Java class containing the method to be called
    `object` - the method, field, or constructor of the Java class to be called

### preEvaluate

    public Expression preEvaluate(StaticContext env)

  preEvaluate: this method suppresses compile-time evaluation by doing nothing (because the external function might have side-effects and might use the context)

  Overrides:
    `preEvaluate` in class `FunctionCall`

### checkArguments

    public void checkArguments(StaticContext env)
                        throws XPathException

  Method called by the expression parser when all arguments have been supplied

  Throws:
    `XPathException`

### getIntrinsicDependencies

    public int getIntrinsicDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE

  Overrides:
    `getIntrinsicDependencies` in class `Expression`
  Returns:
    a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Evaluate the function.

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - The context in which the function is to be evaluated
  Returns:
    a Value representing the result of the function.
  Throws:
    `XPathException` - if the function cannot be evaluated.

### getTargetClass

    public Class getTargetClass()

  Get the class containing the method being called

### getTargetMethod

    public AccessibleObject getTargetMethod()

  Get the target method (or field, or constructor) being called

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the expression, if possible. All expressions return sequences, in general; this method determines the type of the items within the sequence, assuming that (a) this is known in advance, and (b) it is the same for all items in the sequence.

  This method will always return a result, though it may be the best approximation that is available at the time.

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` -
  Returns:
    the item type

### computeCardinality

    public int computeCardinality()

### usesFocus

    public boolean usesFocus()

  Determine whether this method uses the focus. True if the first argument is of type XPathContext.

### toCamelCase

    public static String toCamelCase(String name,
                                     boolean debug,
                                     PrintStream diag)

  Convert a name to camelCase (by removing hyphens and changing the following letter to capitals)

  Parameters:
    `name` - the name to be converted to camelCase
    `debug` - true if tracing is required
  Returns:
    the camelCased name

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.